diff --git a/.azure-pipelines.yml b/.azure-pipelines.yml
index d176e045e1..cb482063cc 100644
--- a/.azure-pipelines.yml
+++ b/.azure-pipelines.yml
@@ -205,18 +205,6 @@ jobs:
         qemu_arm64:
           TEST_PY_BD: "qemu_arm64"
           TEST_PY_TEST_SPEC: "not sleep"
-        qemu_mips:
-          TEST_PY_BD: "qemu_mips"
-          TEST_PY_TEST_SPEC: "not sleep"
-        qemu_mipsel:
-          TEST_PY_BD: "qemu_mipsel"
-          TEST_PY_TEST_SPEC: "not sleep"
-        qemu_mips64:
-          TEST_PY_BD: "qemu_mips64"
-          TEST_PY_TEST_SPEC: "not sleep"
-        qemu_mips64el:
-          TEST_PY_BD: "qemu_mips64el"
-          TEST_PY_TEST_SPEC: "not sleep"
         qemu_malta:
           TEST_PY_BD: "malta"
           TEST_PY_ID: "--id qemu"
diff --git a/.gitlab-ci.yml b/.gitlab-ci.yml
index 51bd64308a..469992f69e 100644
--- a/.gitlab-ci.yml
+++ b/.gitlab-ci.yml
@@ -225,30 +225,6 @@ qemu_arm64 test.py:
     TEST_PY_TEST_SPEC: "not sleep"
   <<: *buildman_and_testpy_dfn
 
-qemu_mips test.py:
-  variables:
-    TEST_PY_BD: "qemu_mips"
-    TEST_PY_TEST_SPEC: "not sleep"
-  <<: *buildman_and_testpy_dfn
-
-qemu_mipsel test.py:
-  variables:
-    TEST_PY_BD: "qemu_mipsel"
-    TEST_PY_TEST_SPEC: "not sleep"
-  <<: *buildman_and_testpy_dfn
-
-qemu_mips64 test.py:
-  variables:
-    TEST_PY_BD: "qemu_mips64"
-    TEST_PY_TEST_SPEC: "not sleep"
-  <<: *buildman_and_testpy_dfn
-
-qemu_mips64el test.py:
-  variables:
-    TEST_PY_BD: "qemu_mips64el"
-    TEST_PY_TEST_SPEC: "not sleep"
-  <<: *buildman_and_testpy_dfn
-
 qemu_malta test.py:
   variables:
     TEST_PY_BD: "malta"
diff --git a/arch/mips/Kconfig b/arch/mips/Kconfig
index 77f563e98e..e54801673b 100644
--- a/arch/mips/Kconfig
+++ b/arch/mips/Kconfig
@@ -12,16 +12,6 @@ choice
 	prompt "Target select"
 	optional
 
-config TARGET_QEMU_MIPS
-	bool "Support qemu-mips"
-	select ROM_EXCEPTION_VECTORS
-	select SUPPORTS_BIG_ENDIAN
-	select SUPPORTS_CPU_MIPS32_R1
-	select SUPPORTS_CPU_MIPS32_R2
-	select SUPPORTS_CPU_MIPS64_R1
-	select SUPPORTS_CPU_MIPS64_R2
-	select SUPPORTS_LITTLE_ENDIAN
-
 config TARGET_MALTA
 	bool "Support malta"
 	select DM
@@ -174,7 +164,6 @@ endchoice
 source "board/imgtec/boston/Kconfig"
 source "board/imgtec/malta/Kconfig"
 source "board/imgtec/xilfpga/Kconfig"
-source "board/qemu-mips/Kconfig"
 source "arch/mips/mach-ath79/Kconfig"
 source "arch/mips/mach-mscc/Kconfig"
 source "arch/mips/mach-bmips/Kconfig"
diff --git a/board/qemu-mips/Kconfig b/board/qemu-mips/Kconfig
deleted file mode 100644
index e696a12192..0000000000
--- a/board/qemu-mips/Kconfig
+++ /dev/null
@@ -1,26 +0,0 @@
-if TARGET_QEMU_MIPS
-
-config SYS_BOARD
-	default "qemu-mips"
-
-config SYS_CONFIG_NAME
-	default "qemu-mips" if 32BIT
-	default "qemu-mips64" if 64BIT
-
-config SYS_TEXT_BASE
-	default 0xbfc00000 if 32BIT
-	default 0xffffffffbfc00000 if 64BIT
-
-config SYS_DCACHE_SIZE
-	default 16384
-
-config SYS_DCACHE_LINE_SIZE
-	default 32
-
-config SYS_ICACHE_SIZE
-	default 16384
-
-config SYS_ICACHE_LINE_SIZE
-	default 32
-
-endif
diff --git a/board/qemu-mips/MAINTAINERS b/board/qemu-mips/MAINTAINERS
deleted file mode 100644
index 334f9d8ee9..0000000000
--- a/board/qemu-mips/MAINTAINERS
+++ /dev/null
@@ -1,14 +0,0 @@
-QEMU-MIPS BOARD
-M:	Vlad Lungu <vlad.lungu@windriver.com>
-S:	Maintained
-F:	board/qemu-mips/
-F:	include/configs/qemu-mips.h
-F:	configs/qemu_mips_defconfig
-
-QEMU_MIPSEL BOARD
-#M:	-
-S:	Maintained
-F:	configs/qemu_mipsel_defconfig
-F:	include/configs/qemu-mips64.h
-F:	configs/qemu_mips64_defconfig
-F:	configs/qemu_mips64el_defconfig
diff --git a/board/qemu-mips/Makefile b/board/qemu-mips/Makefile
deleted file mode 100644
index 98e3874090..0000000000
--- a/board/qemu-mips/Makefile
+++ /dev/null
@@ -1,7 +0,0 @@
-# SPDX-License-Identifier: GPL-2.0+
-#
-# (C) Copyright 2003-2006
-# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
-
-obj-y	= qemu-mips.o
-obj-y	+= lowlevel_init.o
diff --git a/board/qemu-mips/lowlevel_init.S b/board/qemu-mips/lowlevel_init.S
deleted file mode 100644
index b0f7072701..0000000000
--- a/board/qemu-mips/lowlevel_init.S
+++ /dev/null
@@ -1,40 +0,0 @@
-/* Memory sub-system initialization code */
-
-#include <config.h>
-#include <asm/regdef.h>
-#include <asm/mipsregs.h>
-
-	.text
-	.set noreorder
-	.set mips32
-
-	.globl	lowlevel_init
-lowlevel_init:
-
-	/*
-	 * Step 2) Establish Status Register
-	 * (set BEV, clear ERL, clear EXL, clear IE)
-	 */
-	li	t1, 0x00400000
-	mtc0	t1, CP0_STATUS
-
-	/*
-	 * Step 3) Establish CP0 Config0
-	 * (set K0=3)
-	 */
-	li	t1, 0x00000003
-	mtc0	t1, CP0_CONFIG
-
-	/*
-	 * Step 7) Establish Cause
-	 * (set IV bit)
-	 */
-	li	t1, 0x00800000
-	mtc0	t1, CP0_CAUSE
-
-	/* Establish Wired (and Random) */
-	mtc0	zero, CP0_WIRED
-	nop
-
-	jr	ra
-	nop
diff --git a/board/qemu-mips/qemu-mips.c b/board/qemu-mips/qemu-mips.c
deleted file mode 100644
index f57091739e..0000000000
--- a/board/qemu-mips/qemu-mips.c
+++ /dev/null
@@ -1,85 +0,0 @@
-// SPDX-License-Identifier: GPL-2.0+
-/*
- * (C) Copyright 2007
- * Vlad Lungu vlad.lungu@windriver.com
- */
-
-#include <common.h>
-#include <command.h>
-#include <init.h>
-#include <net.h>
-#include <asm/global_data.h>
-#include <asm/mipsregs.h>
-#include <asm/io.h>
-#include <netdev.h>
-
-DECLARE_GLOBAL_DATA_PTR;
-
-int dram_init(void)
-{
-	/* Sdram is setup by assembler code */
-	/* If memory could be changed, we should return the true value here */
-	gd->ram_size = MEM_SIZE * 1024 * 1024;
-
-	return 0;
-}
-
-int checkboard(void)
-{
-	u32 proc_id;
-	u32 config1;
-
-	proc_id = read_c0_prid();
-	printf("Board: Qemu -M mips CPU: ");
-	switch (proc_id) {
-	case 0x00018000:
-		printf("4Kc");
-		break;
-	case 0x00018400:
-		printf("4KEcR1");
-		break;
-	case 0x00019000:
-		printf("4KEc");
-		break;
-	case 0x00019300:
-		config1 = read_c0_config1();
-		if (config1 & 1)
-			printf("24Kf");
-		else
-			printf("24Kc");
-		break;
-	case 0x00019500:
-		printf("34Kf");
-		break;
-	case 0x00000400:
-		printf("R4000");
-		break;
-	case 0x00018100:
-		config1 = read_c0_config1();
-		if (config1 & 1)
-			printf("5Kf");
-		else
-			printf("5Kc");
-		break;
-	case 0x000182a0:
-		printf("20Kc");
-		break;
-
-	default:
-		printf("unknown");
-	}
-	printf(" proc_id=0x%x\n", proc_id);
-
-	return 0;
-}
-
-int misc_init_r(void)
-{
-	set_io_port_base(0);
-	return 0;
-}
-
-int board_eth_init(struct bd_info *bis)
-{
-	return ne2k_register();
-}
diff --git a/configs/qemu_mips64_defconfig b/configs/qemu_mips64_defconfig
deleted file mode 100644
index 30d42ef3ee..0000000000
--- a/configs/qemu_mips64_defconfig
+++ /dev/null
@@ -1,29 +0,0 @@
-CONFIG_MIPS=y
-CONFIG_SYS_TEXT_BASE=0xFFFFFFFFBFC00000
-CONFIG_ENV_SIZE=0x8000
-CONFIG_ENV_SECT_SIZE=0x8000
-CONFIG_TARGET_QEMU_MIPS=y
-CONFIG_CPU_MIPS64_R1=y
-CONFIG_BOOTDELAY=10
-CONFIG_MISC_INIT_R=y
-CONFIG_HUSH_PARSER=y
-CONFIG_SYS_PROMPT="qemu-mips64 # "
-CONFIG_CMD_IMLS=y
-CONFIG_CMD_IDE=y
-# CONFIG_CMD_LOADB is not set
-# CONFIG_CMD_LOADS is not set
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_DHCP=y
-CONFIG_CMD_RARP=y
-CONFIG_CMD_EXT2=y
-CONFIG_CMD_FAT=y
-# CONFIG_ISO_PARTITION is not set
-CONFIG_ENV_OVERWRITE=y
-CONFIG_ENV_IS_IN_FLASH=y
-CONFIG_ENV_ADDR=0xFFFFFFFFBFFF8000
-CONFIG_MTD_NOR_FLASH=y
-CONFIG_FLASH_CFI_DRIVER=y
-CONFIG_SYS_FLASH_USE_BUFFER_WRITE=y
-CONFIG_SYS_FLASH_CFI=y
-CONFIG_SYS_NS16550=y
-CONFIG_LZMA=y
diff --git a/configs/qemu_mips64el_defconfig b/configs/qemu_mips64el_defconfig
deleted file mode 100644
index 4a45d5e0fd..0000000000
--- a/configs/qemu_mips64el_defconfig
+++ /dev/null
@@ -1,30 +0,0 @@
-CONFIG_MIPS=y
-CONFIG_SYS_TEXT_BASE=0xFFFFFFFFBFC00000
-CONFIG_ENV_SIZE=0x8000
-CONFIG_ENV_SECT_SIZE=0x8000
-CONFIG_TARGET_QEMU_MIPS=y
-CONFIG_SYS_LITTLE_ENDIAN=y
-CONFIG_CPU_MIPS64_R1=y
-CONFIG_BOOTDELAY=10
-CONFIG_MISC_INIT_R=y
-CONFIG_HUSH_PARSER=y
-CONFIG_SYS_PROMPT="qemu-mips64el # "
-CONFIG_CMD_IMLS=y
-CONFIG_CMD_IDE=y
-# CONFIG_CMD_LOADB is not set
-# CONFIG_CMD_LOADS is not set
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_DHCP=y
-CONFIG_CMD_RARP=y
-CONFIG_CMD_EXT2=y
-CONFIG_CMD_FAT=y
-# CONFIG_ISO_PARTITION is not set
-CONFIG_ENV_OVERWRITE=y
-CONFIG_ENV_IS_IN_FLASH=y
-CONFIG_ENV_ADDR=0xFFFFFFFFBFFF8000
-CONFIG_MTD_NOR_FLASH=y
-CONFIG_FLASH_CFI_DRIVER=y
-CONFIG_SYS_FLASH_USE_BUFFER_WRITE=y
-CONFIG_SYS_FLASH_CFI=y
-CONFIG_SYS_NS16550=y
-CONFIG_LZMA=y
diff --git a/configs/qemu_mips_defconfig b/configs/qemu_mips_defconfig
deleted file mode 100644
index ebf7af0140..0000000000
--- a/configs/qemu_mips_defconfig
+++ /dev/null
@@ -1,27 +0,0 @@
-CONFIG_MIPS=y
-CONFIG_SYS_TEXT_BASE=0xBFC00000
-CONFIG_ENV_SIZE=0x8000
-CONFIG_ENV_SECT_SIZE=0x8000
-CONFIG_TARGET_QEMU_MIPS=y
-CONFIG_BOOTDELAY=10
-CONFIG_MISC_INIT_R=y
-CONFIG_HUSH_PARSER=y
-CONFIG_SYS_PROMPT="qemu-mips # "
-CONFIG_CMD_IMLS=y
-CONFIG_CMD_IDE=y
-# CONFIG_CMD_LOADB is not set
-# CONFIG_CMD_LOADS is not set
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_DHCP=y
-CONFIG_CMD_EXT2=y
-CONFIG_CMD_FAT=y
-# CONFIG_ISO_PARTITION is not set
-CONFIG_ENV_OVERWRITE=y
-CONFIG_ENV_IS_IN_FLASH=y
-CONFIG_ENV_ADDR=0xBFFF8000
-CONFIG_MTD_NOR_FLASH=y
-CONFIG_FLASH_CFI_DRIVER=y
-CONFIG_SYS_FLASH_USE_BUFFER_WRITE=y
-CONFIG_SYS_FLASH_CFI=y
-CONFIG_SYS_NS16550=y
-CONFIG_LZMA=y
diff --git a/configs/qemu_mipsel_defconfig b/configs/qemu_mipsel_defconfig
deleted file mode 100644
index 03862f7c4f..0000000000
--- a/configs/qemu_mipsel_defconfig
+++ /dev/null
@@ -1,28 +0,0 @@
-CONFIG_MIPS=y
-CONFIG_SYS_TEXT_BASE=0xBFC00000
-CONFIG_ENV_SIZE=0x8000
-CONFIG_ENV_SECT_SIZE=0x8000
-CONFIG_TARGET_QEMU_MIPS=y
-CONFIG_SYS_LITTLE_ENDIAN=y
-CONFIG_BOOTDELAY=10
-CONFIG_MISC_INIT_R=y
-CONFIG_HUSH_PARSER=y
-CONFIG_SYS_PROMPT="qemu-mipsel # "
-CONFIG_CMD_IMLS=y
-CONFIG_CMD_IDE=y
-# CONFIG_CMD_LOADB is not set
-# CONFIG_CMD_LOADS is not set
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_DHCP=y
-CONFIG_CMD_EXT2=y
-CONFIG_CMD_FAT=y
-# CONFIG_ISO_PARTITION is not set
-CONFIG_ENV_OVERWRITE=y
-CONFIG_ENV_IS_IN_FLASH=y
-CONFIG_ENV_ADDR=0xBFFF8000
-CONFIG_MTD_NOR_FLASH=y
-CONFIG_FLASH_CFI_DRIVER=y
-CONFIG_SYS_FLASH_USE_BUFFER_WRITE=y
-CONFIG_SYS_FLASH_CFI=y
-CONFIG_SYS_NS16550=y
-CONFIG_LZMA=y
diff --git a/include/configs/qemu-mips.h b/include/configs/qemu-mips.h
deleted file mode 100644
index 5e787d7209..0000000000
--- a/include/configs/qemu-mips.h
+++ /dev/null
@@ -1,89 +0,0 @@
-/* SPDX-License-Identifier: GPL-2.0+ */
-/*
- * (C) Copyright 2003
- * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
- */
-
-/*
- * This file contains the configuration parameters for qemu-mips target.
- */
-
-#ifndef __CONFIG_H
-#define __CONFIG_H
-
-#define CONFIG_QEMU_MIPS
-
-#define CONFIG_TIMESTAMP		/* Print image info with timestamp */
-
-#define CONFIG_EXTRA_ENV_SETTINGS					\
-	"addmisc=setenv bootargs ${bootargs} "				\
-		"console=ttyS0,${baudrate} "				\
-		"panic=1\0"						\
-	"bootfile=/tftpboot/vmlinux\0"				\
-	"load=tftp 80500000 ${u-boot}\0"				\
-	""
-
-#define CONFIG_BOOTCOMMAND	"bootp;bootelf"
-
-/*
- * BOOTP options
- */
-#define CONFIG_BOOTP_BOOTFILESIZE
-
-#define CONFIG_DRIVER_NE2000
-#define CONFIG_DRIVER_NE2000_BASE	0xb4000300
-
-#define CONFIG_SYS_NS16550_SERIAL
-#define CONFIG_SYS_NS16550_REG_SIZE	1
-#define CONFIG_SYS_NS16550_CLK		115200
-#define CONFIG_SYS_NS16550_COM1		0xb40003f8
-
-#ifdef CONFIG_SYS_BIG_ENDIAN
-#define CONFIG_IDE_SWAP_IO
-#endif
-
-#define CONFIG_SYS_IDE_MAXBUS		2
-#define CONFIG_SYS_ATA_IDE0_OFFSET	0x1f0
-#define CONFIG_SYS_ATA_IDE1_OFFSET	0x170
-#define CONFIG_SYS_ATA_DATA_OFFSET	0
-#define CONFIG_SYS_ATA_REG_OFFSET	0
-#define CONFIG_SYS_ATA_BASE_ADDR	0xb4000000
-
-#define CONFIG_SYS_IDE_MAXDEVICE	4
-
-/*
- * Miscellaneous configurable options
- */
-
-#define CONFIG_SYS_MALLOC_LEN		(256 << 10)
-
-#define CONFIG_SYS_BOOTPARAMS_LEN	128*1024
-
-#define CONFIG_SYS_MHZ			132
-
-#define CONFIG_SYS_MIPS_TIMER_FREQ	(CONFIG_SYS_MHZ * 1000000)
-
-/* Cached addr */
-#define CONFIG_SYS_SDRAM_BASE		0x80000000
-
-/* default load address */
-#define CONFIG_SYS_LOAD_ADDR		0x81000000
-
-/*-----------------------------------------------------------------------
- * FLASH and environment organization
- */
-/* The following #defines are needed to get flash environment right */
-#define CONFIG_SYS_MONITOR_BASE	CONFIG_SYS_TEXT_BASE
-
-#define CONFIG_SYS_INIT_SP_OFFSET	0x400000
-
-/* We boot from this flash, selected with dip switch */
-#define CONFIG_SYS_FLASH_BASE		0xbfc00000
-#define CONFIG_SYS_MAX_FLASH_BANKS	1
-#define CONFIG_SYS_MAX_FLASH_SECT	128
-
-/* Address and size of Primary Environment Sector */
-
-#define MEM_SIZE		128
-
-#endif /* __CONFIG_H */
diff --git a/include/configs/qemu-mips64.h b/include/configs/qemu-mips64.h
deleted file mode 100644
index 0ed00bc88f..0000000000
--- a/include/configs/qemu-mips64.h
+++ /dev/null
@@ -1,89 +0,0 @@
-/* SPDX-License-Identifier: GPL-2.0+ */
-/*
- * (C) Copyright 2003
- * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
- */
-
-/*
- * This file contains the configuration parameters for qemu-mips64 target.
- */
-
-#ifndef __CONFIG_H
-#define __CONFIG_H
-
-#define CONFIG_QEMU_MIPS
-
-#define CONFIG_TIMESTAMP		/* Print image info with timestamp */
-
-#define CONFIG_EXTRA_ENV_SETTINGS					\
-	"addmisc=setenv bootargs ${bootargs} "				\
-		"console=ttyS0,${baudrate} "				\
-		"panic=1\0"						\
-	"bootfile=/tftpboot/vmlinux\0"					\
-	"load=tftp ffffffff80500000 ${u-boot}\0"			\
-	""
-
-#define CONFIG_BOOTCOMMAND	"bootp;bootelf"
-
-/*
- * BOOTP options
- */
-#define CONFIG_BOOTP_BOOTFILESIZE
-
-#define CONFIG_DRIVER_NE2000
-#define CONFIG_DRIVER_NE2000_BASE	0xffffffffb4000300
-
-#define CONFIG_SYS_NS16550_SERIAL
-#define CONFIG_SYS_NS16550_REG_SIZE	1
-#define CONFIG_SYS_NS16550_CLK		115200
-#define CONFIG_SYS_NS16550_COM1		0xffffffffb40003f8
-
-#ifdef CONFIG_SYS_BIG_ENDIAN
-#define CONFIG_IDE_SWAP_IO
-#endif
-
-#define CONFIG_SYS_IDE_MAXBUS		2
-#define CONFIG_SYS_ATA_IDE0_OFFSET	0x1f0
-#define CONFIG_SYS_ATA_IDE1_OFFSET	0x170
-#define CONFIG_SYS_ATA_DATA_OFFSET	0
-#define CONFIG_SYS_ATA_REG_OFFSET	0
-#define CONFIG_SYS_ATA_BASE_ADDR	0xffffffffb4000000
-
-#define CONFIG_SYS_IDE_MAXDEVICE	4
-
-/*
- * Miscellaneous configurable options
- */
-
-#define CONFIG_SYS_MALLOC_LEN		(256 << 10)
-
-#define CONFIG_SYS_BOOTPARAMS_LEN	128*1024
-
-#define CONFIG_SYS_MHZ			132
-
-#define CONFIG_SYS_MIPS_TIMER_FREQ	(CONFIG_SYS_MHZ * 1000000)
-
-/* Cached addr */
-#define CONFIG_SYS_SDRAM_BASE		0xffffffff80000000
-
-/* default load address */
-#define CONFIG_SYS_LOAD_ADDR		0xffffffff81000000
-
-/*-----------------------------------------------------------------------
- * FLASH and environment organization
- */
-/* The following #defines are needed to get flash environment right */
-#define CONFIG_SYS_MONITOR_BASE	CONFIG_SYS_TEXT_BASE
-
-#define CONFIG_SYS_INIT_SP_OFFSET	0x400000
-
-/* We boot from this flash, selected with dip switch */
-#define CONFIG_SYS_FLASH_BASE		0xffffffffbfc00000
-#define CONFIG_SYS_MAX_FLASH_BANKS	1
-#define CONFIG_SYS_MAX_FLASH_SECT	128
-
-/* Address and size of Primary Environment Sector */
-
-#define MEM_SIZE		128
-
-#endif /* __CONFIG_H */
diff --git a/scripts/config_whitelist.txt b/scripts/config_whitelist.txt
index a2fcafd2e6..981c9d5963 100644
--- a/scripts/config_whitelist.txt
+++ b/scripts/config_whitelist.txt
@@ -1308,7 +1308,6 @@ CONFIG_PXA_STD_I2C
 CONFIG_PXA_VGA
 CONFIG_PXA_VIDEO
 CONFIG_QBMAN_CLK_DIV
-CONFIG_QEMU_MIPS
 CONFIG_QIXIS_I2C_ACCESS
 CONFIG_QSPI
 CONFIG_QUOTA